"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.getFunctionMap = exports.AWSLambdaAPI = void 0;
var radash_1 = __importDefault(require("radash"));
var pulumi = __importStar(require("@pulumi/pulumi"));
var aws = __importStar(require("@pulumi/aws"));
var awsx = __importStar(require("@pulumi/awsx"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var cmdish_1 = __importDefault(require("cmdish"));
var path_1 = __importDefault(require("path"));
/**
 * Static website using Amazon S3, CloudFront, and Route53.
 */
var AWSLambdaAPI = /** @class */ (function (_super) {
    __extends(AWSLambdaAPI, _super);
    function AWSLambdaAPI(name, args, opts) {
        var _this = this;
        var inputs = {
            options: opts
        };
        _this = _super.call(this, 'exo:components:aws-lambda-api', name, inputs, opts) || this;
        var apiName = radash_1["default"].dashCase("".concat(name, "-api"));
        var iamRoleName = radash_1["default"].dashCase("".concat(name, "-iam-lambda"));
        /**
         * aws component will add a dash and 7 rand chars to our name and
         * the aws limit is 64. We need to trim it if its over
         * limit = 64 - (dash = 1) - (rand = 7)
         */
        var lambdaName = function (module, func) {
            var n = radash_1["default"].dashCase("".concat(name, "-").concat(module, "-").concat(func));
            return n.length > 56
                ? n.slice(0, 56 - n.length)
                : n;
        };
        //
        //  DETERMINE API SHAPE FROM SOURCE
        //
        var functions = getFunctionMap({
            path: args.sourceDir,
            ext: args.sourceExt
        });
        //
        //  BUILD NEEDED FUNCTIONS
        //
        var zipPath = buildTypescriptLambdaZip({
            path: args.sourceDir
        });
        //
        //  CREATE NEEDED ROLE/POLICY
        //
        var iamForLambda = new aws.iam.Role(iamRoleName, {
            assumeRolePolicy: "{\n      \"Version\": \"2012-10-17\",\n      \"Statement\": [\n        {\n          \"Action\": \"sts:AssumeRole\",\n          \"Principal\": {\n            \"Service\": \"lambda.amazonaws.com\"\n          },\n          \"Effect\": \"Allow\",\n          \"Sid\": \"\"\n        }\n      ]\n    }"
        }, opts);
        var lambdaLoggingPolicy = new aws.iam.Policy("lambdaLogging", {
            path: "/",
            description: "IAM policy for logging from a lambda",
            policy: "{\n      \"Version\": \"2012-10-17\",\n      \"Statement\": [\n        {\n          \"Action\": [\n            \"logs:CreateLogGroup\",\n            \"logs:CreateLogStream\",\n            \"logs:PutLogEvents\"\n          ],\n          \"Resource\": \"arn:aws:logs:*:*:*\",\n          \"Effect\": \"Allow\"\n        }\n      ]\n    }\n    "
        }, opts);
        var loggingPolicyAttachment = new aws.iam.RolePolicyAttachment("lambdaLogs", {
            role: iamForLambda.name,
            policyArn: lambdaLoggingPolicy.arn
        }, opts);
        //
        //  CREATE LAMBDA FOR EACH FUNCTION
        //
        var zipSource = new pulumi.asset.FileArchive(zipPath);
        var envvars = args.environmentVariables.reduce(function (acc, envvar) {
            var _a;
            return (__assign(__assign({}, acc), (_a = {}, _a[envvar.name] = envvar.value, _a)));
        }, {});
        var lambdas = functions.map(function (func) {
            var lambda = new aws.lambda.Function(lambdaName(func.module, func["function"]), {
                code: zipSource,
                role: iamForLambda.arn,
                handler: "modules/".concat(func.module, "/").concat(func["function"], ".default"),
                runtime: 'nodejs14.x',
                environment: {
                    variables: envvars
                }
            }, __assign(__assign({}, opts), { dependsOn: [
                    loggingPolicyAttachment
                ] }));
            return __assign(__assign({}, func), { lambda: lambda });
        });
        _this.lambdas = lambdas.map(function (l) { return l.lambda; });
        //
        //  CREATE API GATEWAY ENDPOINTS FOR EACH FUNCTION
        //
        var api = new awsx.apigateway.API(apiName, {
            routes: lambdas.map(function (lambda) { return ({
                path: "/".concat(lambda.module, "/").concat(lambda["function"]),
                method: 'ANY',
                eventHandler: lambda.lambda
            }); }),
            stageName: 'api'
        }, opts);
        _this.api = api.restAPI;
        //
        //  SETUP CUSTOM DOMAIN (if specified)
        //
        if (args.domain) {
            var cert = pulumi.output(aws.acm.getCertificate({
                domain: args.domain.subdomain
                    ? "*.".concat(args.domain.domain)
                    : args.domain.domain,
                mostRecent: true,
                types: ["AMAZON_ISSUED"]
            }, opts));
            var domainName = new aws.apigateway.DomainName(radash_1["default"].dashCase(args.domain.fqd), {
                certificateArn: cert.arn,
                domainName: args.domain.fqd
            }, opts);
            new aws.apigateway.BasePathMapping(radash_1["default"].dashCase("".concat(args.domain.fqd, "-mapping")), {
                restApi: api.restAPI,
                stageName: api.stage.stageName,
                domainName: domainName.domainName
            }, opts);
            var zone = pulumi.output(aws.route53.getZone({
                name: args.domain.domain,
                privateZone: false
            }, opts));
            /**
             * Really odd use of cloud front args here. See this terraform
             * doc for clarification. TLDR; api gateway is using cloud front
             * under the hood.
             * https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/api_gateway_domain_name
             */
            _this.aRecord = new aws.route53.Record(radash_1["default"].dashCase("".concat(args.domain.fqd, "-record")), {
                zoneId: zone.id,
                name: domainName.domainName,
                type: "A",
                aliases: [{
                        name: domainName.cloudfrontDomainName,
                        zoneId: domainName.cloudfrontZoneId,
                        evaluateTargetHealth: false
                    }]
            }, __assign(__assign({}, opts), { dependsOn: [
                    domainName
                ] }));
        }
        return _this;
    }
    return AWSLambdaAPI;
}(pulumi.ComponentResource));
exports.AWSLambdaAPI = AWSLambdaAPI;
var buildTypescriptLambdaZip = function (_a) {
    var path = _a.path;
    return __awaiter(void 0, void 0, void 0, function () {
        var root, build, zip, USE_NVM, err, err;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    root = path;
                    build = "".concat(root, "/build");
                    zip = "".concat(root, "/aws-lambda-api.zip");
                    USE_NVM = !!process.env.USE_NVM;
                    //
                    // Add files and install dependencies
                    //
                    return [4 /*yield*/, fs_extra_1["default"].copy("".concat(root, "/package.json"), "".concat(build, "/package.json"))];
                case 1:
                    //
                    // Add files and install dependencies
                    //
                    _b.sent();
                    if (!USE_NVM) return [3 /*break*/, 3];
                    return [4 /*yield*/, (0, cmdish_1["default"])('source ~/.nvm/nvm.sh && nvm use && yarn && yarn build && cd build && yarn --prod', { cwd: root })];
                case 2:
                    err = (_b.sent())[0];
                    if (err)
                        throw err;
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, (0, cmdish_1["default"])('yarn && yarn build && cd build && yarn --prod', { cwd: root })];
                case 4:
                    err = (_b.sent())[0];
                    if (err)
                        throw err;
                    _b.label = 5;
                case 5: 
                //
                // Generate new zip
                //
                return [4 /*yield*/, (0, cmdish_1["default"])("zip -q -r ".concat(zip, " *"), { cwd: build })];
                case 6:
                    //
                    // Generate new zip
                    //
                    _b.sent();
                    return [2 /*return*/, zip];
            }
        });
    });
};
/**
 * Looks in ./src/modules for your modules and
 * functions. Returns their names and locations
 * as an array.
 */
function getFunctionMap(_a) {
    var rootPath = _a.path, ext = _a.ext;
    var relPath = function (rel) { return path_1["default"].join(rootPath, rel); };
    var modules = fs_extra_1["default"].readdirSync(relPath('/src/modules'), { withFileTypes: true })
        .filter(function (item) { return item.isDirectory(); })
        .map(function (m) {
        return fs_extra_1["default"].readdirSync(relPath("/src/modules/".concat(m.name)), { withFileTypes: true })
            .filter(function (item) { return !item.isDirectory(); })
            .filter(function (item) { return item.name.endsWith(".".concat(ext)); })
            .map(function (tsFile) {
            var funcName = tsFile.name.replace(".".concat(ext), '');
            return {
                "function": funcName,
                module: m.name,
                paths: {
                    file: relPath("/src/modules/".concat(m.name, "/").concat(tsFile.name)),
                    "import": relPath("/src/modules/".concat(m.name, "/").concat(funcName))
                }
            };
        });
    });
    return radash_1["default"].flat(modules);
}
exports.getFunctionMap = getFunctionMap;
//# sourceMappingURL=index.js.map